zoukankan      html  css  js  c++  java
  • hdu 2955 Robberies 背包DP

    Robberies

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
    Total Submission(s): 12161    Accepted Submission(s): 4527


    Problem Description
    The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.


    For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.


    His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.
     
    Input
    The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj . 
    Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .
     
    Output
    For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

    Notes and Constraints
    0 < T <= 100
    0.0 <= P <= 1.0
    0 < N <= 100
    0 < Mj <= 100
    0.0 <= Pj <= 1.0
    A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.
     
    Sample Input
    3 0.04 3 1 0.02 2 0.03 3 0.05 0.06 3 2 0.03 2 0.03 3 0.05 0.10 3 1 0.03 2 0.02 3 0.05
     
    Sample Output
    2 4 6
     
    Source
     
      這種時候還做揹包問題確實有點不正常,但是這道題內蘊含了一種揹包問題的思路,即在有些題目中兩個量都可以作爲揹包的下標,而需要仔細分析兩者優劣。
      這道題就是這種典型揹包問題,由於用概率×10000作爲下標會爆精度所以最佳方法爲用金錢作爲下標。
     
    順便粘上兩個代碼。
    #include<iostream>
    #include<cstdio>
    #include<cstdlib>
    #include<cstring>
    #include<ctime>
    #include<cmath>
    #include<algorithm>
    #include<set>
    #include<map>
    #include<vector>
    #include<string>
    #include<queue>
    using namespace std;
    #ifdef WIN32
    #define LL "%I64d"
    #else
    #define LL "%lld"
    #endif
    #define MAXN 10010
    #define MAXV MAXN*2
    #define MAXE MAXV*2
    #define INF 0x3f3f3f3f
    #define INFL 0x3f3f3f3f3f3f3f3fLL
    typedef long long qword;
    inline int nextInt()
    {
            char ch;
            int x=0;
            bool flag=false;
            do
                    ch=getchar(),flag=(ch=='-')?true:flag;
            while(ch<'0'||ch>'9');
            do x=x*10+ch-'0';
            while (ch=getchar(),ch<='9' && ch>='0');
            return x*(flag?-1:1);
    }
    double f[MAXN+100];
    int n,m;
    int main()
    {
            freopen("input.txt","r",stdin);
            //freopen("output.txt","w",stdout);
                    int i,j,k;
            int x,y,z;
            int nn;
            scanf("%d",&nn);
            double temp;
            double plim;
            double p;
            int tot;
            int l;
            int ii;
            for (ii=0;ii<nn;ii++)
            {
                    scanf("%lf %d",&temp,&n);
                    plim=(1-temp);
                    int ans=0;
                    for (i=0;i<=MAXN;i++)f[i]=0;
                    f[0]=1;
                    for (i=0;i<n;i++)
                    {
                            scanf("%d %lf",&tot,&p);
                            p=(1-p);
                            for (j=MAXN;j>=0;j--)
                            {
                                    f[j+tot]=max(f[j+tot],f[j]*p);
                                    if (f[j+tot]>plim)ans=max(ans,j+tot);
                            }
                    }
                    printf("%d
    ",ans);
            }
            return 0;
    }
    #include<iostream>
    #include<cstdio>
    #include<cstdlib>
    #include<cstring>
    #include<ctime>
    #include<cmath>
    #include<algorithm>
    #include<set>
    #include<map>
    #include<vector>
    #include<string>
    #include<queue>
    using namespace std;
    #ifdef WIN32
    #define LL "%I64d"
    #else
    #define LL "%lld"
    #endif
    #define MAXN 100000
    #define MAXV MAXN*2
    #define MAXE MAXV*2
    #define INF 0x3f3f3f3f
    #define INFL 0x3f3f3f3f3f3f3f3fLL
    typedef long long qword;
    inline int nextInt()
    {
            char ch;
            int x=0;
            bool flag=false;
            do
                    ch=getchar(),flag=(ch=='-')?true:flag;
            while(ch<'0'||ch>'9');
            do x=x*10+ch-'0';
            while (ch=getchar(),ch<='9' && ch>='0');
            return x*(flag?-1:1);
    }
    int f[MAXN+100];
    int n,m;
    int main()
    {
            //freopen("input.txt","r",stdin);
            //freopen("output.txt","w",stdout);
            int i,j,k;
            int x,y,z;
            int nn;
            scanf("%d",&nn);
            double temp;
            int plim;
            double p;
            int tot;
            int l;
            int ii;
            for (ii=0;ii<nn;ii++)
            {
                    scanf("%lf %d",&temp,&n);
                    plim=(1-temp)*MAXN;
                    int ans=0;
                    memset(f,-INF,sizeof(f));
                    f[MAXN]=0;
                    for (i=0;i<n;i++)
                    {
                            scanf("%d %lf",&tot,&p);
                            p=(1-p);
                            for (j=plim/p;j<=MAXN;j++)
                            {
                                    if (j*p<=plim)continue;
                                    f[(int)(j*p)]=max(f[(int)(j*p)],f[j]+tot);
                                    ans=max(ans,f[(int)(j*p)]);
                            }
                    }
                    printf("%d
    ",ans);
            }
            return 0;
    }
    by mhy12345(http://www.cnblogs.com/mhy12345/) 未经允许请勿转载

    本博客已停用,新博客地址:http://mhy12345.xyz

  • 相关阅读:
    高精度计算
    高精度除以低精度
    P1258 小车问题
    POJ 2352 stars (树状数组入门经典!!!)
    HDU 3635 Dragon Balls(超级经典的带权并查集!!!新手入门)
    HDU 3938 Portal (离线并查集,此题思路很强!!!,得到所谓的距离很巧妙)
    POJ 1703 Find them, Catch them(确定元素归属集合的并查集)
    HDU Virtual Friends(超级经典的带权并查集)
    HDU 3047 Zjnu Stadium(带权并查集,难想到)
    HDU 3038 How Many Answers Are Wrong(带权并查集,真的很难想到是个并查集!!!)
  • 原文地址:https://www.cnblogs.com/mhy12345/p/3986559.html
Copyright © 2011-2022 走看看